3 # Copyright (c) 2006 Johannes E. Schindelin
7 # This script makes it easy to fix up commits in the middle of a series,
8 # and rearrange commits.
10 # The original idea comes from Eric W. Biederman, in
11 # http://article.gmane.org/gmane.comp.version-control.git/22407
15 git-rebase [-i] [options] [--] <upstream> [<branch>]
16 git-rebase [-i] (--continue | --abort | --skip)
19 v,verbose display a diffstat of what changed upstream
20 onto= rebase onto given branch instead of upstream
21 p,preserve-merges try to recreate merges instead of ignoring them
22 s,strategy= use the given merge strategy
23 m,merge always used (no-op)
24 i,interactive always used (no-op)
26 continue continue rebasing process
27 abort abort rebasing process and restore original branch
28 skip skip current patch and continue rebasing process
29 no-verify override pre-rebase hook from stopping the operation
30 root rebase all reachable commmits up to the root(s)
36 DOTEST="$GIT_DIR/rebase-merge"
37 TODO="$DOTEST"/git-rebase-todo
40 SQUASH_MSG="$DOTEST"/message-squash
41 REWRITTEN="$DOTEST"/rewritten
42 DROPPED="$DOTEST"/dropped
47 OK_TO_SKIP_PRE_REBASE=
50 GIT_CHERRY_PICK_HELP=" After resolving the conflicts,
51 mark the corrected paths with 'git add <paths>', and
52 run 'git rebase --continue'"
53 export GIT_CHERRY_PICK_HELP
64 test $status != 0 && printf "%s\n" "$output"
73 run_pre_rebase_hook () {
74 if test -z "$OK_TO_SKIP_PRE_REBASE" &&
75 test -x "$GIT_DIR/hooks/pre-rebase"
77 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
78 echo >&2 "The pre-rebase hook refused to rebase."
84 require_clean_work_tree () {
85 # test if working tree is dirty
86 git rev-parse --verify HEAD > /dev/null &&
87 git update-index --ignore-submodules --refresh &&
88 git diff-files --quiet --ignore-submodules &&
89 git diff-index --cached --quiet HEAD --ignore-submodules -- ||
90 die "Working tree is dirty"
93 ORIG_REFLOG_ACTION="$GIT_REFLOG_ACTION"
95 comment_for_reflog () {
96 case "$ORIG_REFLOG_ACTION" in
98 GIT_REFLOG_ACTION="rebase -i ($1)"
99 export GIT_REFLOG_ACTION
105 mark_action_done () {
106 sed -e 1q < "$TODO" >> "$DONE"
107 sed -e 1d < "$TODO" >> "$TODO".new
108 mv -f "$TODO".new "$TODO"
109 count=$(sane_grep -c '^[^#]' < "$DONE")
110 total=$(($count+$(sane_grep -c '^[^#]' < "$TODO")))
111 if test "$last_count" != "$count"
114 printf "Rebasing (%d/%d)\r" $count $total
115 test -z "$VERBOSE" || echo
120 sha1_and_parents="$(git rev-list --parents -1 "$1")"
121 case "$sha1_and_parents" in
123 git diff --cc $sha1_and_parents
126 git diff-tree -p "$1^!"
131 esac > "$DOTEST"/patch
132 test -f "$DOTEST"/message ||
133 git cat-file commit "$1" | sed "1,/^$/d" > "$DOTEST"/message
134 test -f "$DOTEST"/author-script ||
135 get_author_ident_from_commit "$1" > "$DOTEST"/author-script
150 sane_grep '^[^#]' "$1" >/dev/null
155 case "$1" in -n) sha1=$2; no_ff=t ;; *) sha1=$1 ;; esac
156 output git rev-parse --verify $sha1 || die "Invalid commit name: $sha1"
157 test -d "$REWRITTEN" &&
158 pick_one_preserving_merges "$@" && return
159 if test ! -z "$REBASE_ROOT"
161 output git cherry-pick "$@"
164 parent_sha1=$(git rev-parse --verify $sha1^) ||
165 die "Could not get the parent of $sha1"
166 current_sha1=$(git rev-parse --verify HEAD)
167 if test "$no_ff$current_sha1" = "$parent_sha1"; then
168 output git reset --hard $sha1
169 test "a$1" = a-n && output git reset --soft $current_sha1
170 sha1=$(git rev-parse --short $sha1)
171 output warn Fast-forward to $sha1
173 output git cherry-pick "$@"
177 pick_one_preserving_merges () {
188 sha1=$(git rev-parse $sha1)
190 if test -f "$DOTEST"/current-commit
192 if test "$fast_forward" = t
194 cat "$DOTEST"/current-commit | while read current_commit
196 git rev-parse HEAD > "$REWRITTEN"/$current_commit
198 rm "$DOTEST"/current-commit ||
199 die "Cannot write current commit's replacement sha1"
203 echo $sha1 >> "$DOTEST"/current-commit
205 # rewrite parents; if none were rewritten, we can fast-forward.
207 pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
208 if test "$pend" = " "
212 while [ "$pend" != "" ]
214 p=$(expr "$pend" : ' \([^ ]*\)')
217 if test -f "$REWRITTEN"/$p
219 new_p=$(cat "$REWRITTEN"/$p)
221 # If the todo reordered commits, and our parent is marked for
222 # rewriting, but hasn't been gotten to yet, assume the user meant to
223 # drop it on top of the current HEAD
226 new_p=$(git rev-parse HEAD)
229 test $p != $new_p && fast_forward=f
230 case "$new_parents" in
232 ;; # do nothing; that parent is already there
234 new_parents="$new_parents $new_p"
238 if test -f "$DROPPED"/$p
241 replacement="$(cat "$DROPPED"/$p)"
242 test -z "$replacement" && replacement=root
243 pend=" $replacement$pend"
245 new_parents="$new_parents $p"
249 case $fast_forward in
251 output warn "Fast-forward to $sha1"
252 output git reset --hard $sha1 ||
253 die "Cannot fast-forward to $sha1"
256 first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
260 # detach HEAD to current parent
261 output git checkout $first_parent 2> /dev/null ||
262 die "Cannot move HEAD to $first_parent"
265 case "$new_parents" in
267 test "a$1" = a-n && die "Refusing to squash a merge: $sha1"
270 author_script=$(get_author_ident_from_commit $sha1)
271 eval "$author_script"
272 msg="$(git cat-file commit $sha1 | sed -e '1,/^$/d')"
273 # No point in merging the first parent, that's HEAD
274 new_parents=${new_parents# $first_parent}
275 if ! GIT_AUTHOR_NAME="$GIT_AUTHOR_NAME" \
276 GIT_AUTHOR_EMAIL="$GIT_AUTHOR_EMAIL" \
277 GIT_AUTHOR_DATE="$GIT_AUTHOR_DATE" \
278 output git merge $STRATEGY -m "$msg" \
281 printf "%s\n" "$msg" > "$GIT_DIR"/MERGE_MSG
282 die_with_patch $sha1 "Error redoing merge $sha1"
286 output git cherry-pick "$@" ||
287 die_with_patch $sha1 "Could not pick $sha1"
296 *1[0-9]|*[04-9]) echo "$1"th;;
303 make_squash_message () {
304 if test -f "$SQUASH_MSG"; then
305 COUNT=$(($(sed -n "s/^# This is [^0-9]*\([1-9][0-9]*\).*/\1/p" \
306 < "$SQUASH_MSG" | sed -ne '$p')+1))
307 echo "# This is a combination of $COUNT commits."
308 sed -e 1d -e '2,/^./{
313 echo "# This is a combination of two commits."
314 echo "# The first commit's message is:"
316 git cat-file commit HEAD | sed -e '1,/^$/d'
319 echo "# This is the $(nth_string $COUNT) commit message:"
321 git cat-file commit $1 | sed -e '1,/^$/d'
324 peek_next_command () {
325 sed -n -e "/^#/d" -e "/^$/d" -e "s/ .*//p" -e "q" < "$TODO"
329 rm -f "$DOTEST"/message "$DOTEST"/author-script \
330 "$DOTEST"/amend || exit
331 read command sha1 rest < "$TODO"
337 comment_for_reflog pick
341 die_with_patch $sha1 "Could not apply $sha1... $rest"
344 comment_for_reflog reword
348 die_with_patch $sha1 "Could not apply $sha1... $rest"
352 comment_for_reflog edit
356 die_with_patch $sha1 "Could not apply $sha1... $rest"
358 git rev-parse --verify HEAD > "$DOTEST"/amend
359 warn "Stopped at $sha1... $rest"
360 warn "You can amend the commit now, with"
362 warn " git commit --amend"
364 warn "Once you are satisfied with your changes, run"
366 warn " git rebase --continue"
371 comment_for_reflog squash
373 test -f "$DONE" && has_action "$DONE" ||
374 die "Cannot 'squash' without a previous commit"
377 make_squash_message $sha1 > "$MSG"
379 author_script=$(get_author_ident_from_commit HEAD)
380 output git reset --soft HEAD^
381 pick_one -n $sha1 || failed=t
382 case "$(peek_next_command)" in
387 cp "$MSG" "$SQUASH_MSG"
393 rm -f "$SQUASH_MSG" || exit
394 cp "$MSG" "$GIT_DIR"/SQUASH_MSG
395 rm -f "$GIT_DIR"/MERGE_MSG || exit
398 echo "$author_script" > "$DOTEST"/author-script
401 # This is like --amend, but with a different message
402 eval "$author_script"
403 GIT_AUTHOR_NAME="$GIT_AUTHOR_NAME" \
404 GIT_AUTHOR_EMAIL="$GIT_AUTHOR_EMAIL" \
405 GIT_AUTHOR_DATE="$GIT_AUTHOR_DATE" \
406 $USE_OUTPUT git commit --no-verify \
407 $MSG_OPT "$EDIT_OR_FILE" || failed=t
411 cp "$MSG" "$GIT_DIR"/MERGE_MSG
413 warn "Could not apply $sha1... $rest"
414 die_with_patch $sha1 ""
418 warn "Unknown command: $command $sha1 $rest"
419 if git rev-parse --verify -q "$sha1" >/dev/null
421 die_with_patch $sha1 "Please fix this in the file $TODO."
423 die "Please fix this in the file $TODO."
427 test -s "$TODO" && return
429 comment_for_reflog finish &&
430 HEADNAME=$(cat "$DOTEST"/head-name) &&
431 OLDHEAD=$(cat "$DOTEST"/head) &&
432 SHORTONTO=$(git rev-parse --short $(cat "$DOTEST"/onto)) &&
433 NEWHEAD=$(git rev-parse HEAD) &&
436 message="$GIT_REFLOG_ACTION: $HEADNAME onto $SHORTONTO" &&
437 git update-ref -m "$message" $HEADNAME $NEWHEAD $OLDHEAD &&
438 git symbolic-ref HEAD $HEADNAME
441 test ! -f "$DOTEST"/verbose ||
442 git diff-tree --stat $(cat "$DOTEST"/head)..HEAD
446 warn "Successfully rebased and updated $HEADNAME."
458 # skip picking commits whose parents are unchanged
459 skip_unnecessary_picks () {
461 while read command sha1 rest
463 # fd=3 means we skip the command
464 case "$fd,$command,$(git rev-parse --verify --quiet $sha1^)" in
465 3,pick,"$ONTO"*|3,p,"$ONTO"*)
466 # pick a commit whose parent is current $ONTO -> skip
476 echo "$command${sha1:+ }$sha1${rest:+ }$rest" >&$fd
477 done <"$TODO" >"$TODO.new" 3>>"$DONE" &&
478 mv -f "$TODO".new "$TODO" ||
479 die "Could not skip unnecessary pick commands"
482 # check if no other options are set
484 test $# -eq 2 -a "$2" = '--' &&
486 test -z "$PRESERVE_MERGES" &&
487 test -z "$STRATEGY" &&
491 get_saved_options () {
492 test -d "$REWRITTEN" && PRESERVE_MERGES=t
493 test -f "$DOTEST"/strategy && STRATEGY="$(cat "$DOTEST"/strategy)"
494 test -f "$DOTEST"/verbose && VERBOSE=t
495 test -f "$DOTEST"/rebase-root && REBASE_ROOT=t
502 OK_TO_SKIP_PRE_REBASE=yes
507 is_standalone "$@" || usage
509 comment_for_reflog continue
511 test -d "$DOTEST" || die "No interactive rebase running"
514 git rev-parse --verify HEAD >/dev/null ||
515 die "Cannot read HEAD"
516 git update-index --ignore-submodules --refresh &&
517 git diff-files --quiet --ignore-submodules ||
518 die "Working tree is dirty"
520 # do we have anything to commit?
521 if git diff-index --cached --quiet --ignore-submodules HEAD --
523 : Nothing to commit -- skip this
525 . "$DOTEST"/author-script ||
526 die "Cannot find the author identity"
528 if test -f "$DOTEST"/amend
530 amend=$(git rev-parse --verify HEAD)
531 test "$amend" = $(cat "$DOTEST"/amend) ||
533 You have uncommitted changes in your working tree. Please, commit them
534 first and then run 'git rebase --continue' again."
535 git reset --soft HEAD^ ||
536 die "Cannot rewind the HEAD"
538 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE &&
539 git commit --no-verify -F "$DOTEST"/message -e || {
540 test -n "$amend" && git reset --soft $amend
541 die "Could not commit staged changes."
545 require_clean_work_tree
549 is_standalone "$@" || usage
551 comment_for_reflog abort
554 test -d "$DOTEST" || die "No interactive rebase running"
556 HEADNAME=$(cat "$DOTEST"/head-name)
557 HEAD=$(cat "$DOTEST"/head)
560 git symbolic-ref HEAD $HEADNAME
563 output git reset --hard $HEAD &&
568 is_standalone "$@" || usage
570 comment_for_reflog skip
573 test -d "$DOTEST" || die "No interactive rebase running"
575 output git reset --hard && do_rest
580 STRATEGY="-s "$(expr "z$1" : 'z-[^=]*=\(.*\)') ;;
589 # we use merge anyway
605 ONTO=$(git rev-parse --verify "$1") ||
606 die "Does not point to a valid commit: $1"
610 test -z "$REBASE_ROOT" -a $# -ge 1 -a $# -le 2 ||
611 test ! -z "$REBASE_ROOT" -a $# -le 1 || usage
613 die "Interactive rebase already started"
615 git var GIT_COMMITTER_IDENT >/dev/null ||
616 die "You need to set your committer info first"
618 if test -z "$REBASE_ROOT"
621 UPSTREAM=$(git rev-parse --verify "$1") || die "Invalid base"
622 test -z "$ONTO" && ONTO=$UPSTREAM
628 die "You must specify --onto when using --root"
630 run_pre_rebase_hook "$UPSTREAM_ARG" "$@"
632 comment_for_reflog start
634 require_clean_work_tree
638 output git show-ref --verify --quiet "refs/heads/$1" ||
639 die "Invalid branchname: $1"
640 output git checkout "$1" ||
641 die "Could not checkout $1"
644 HEAD=$(git rev-parse --verify HEAD) || die "No HEAD?"
645 mkdir "$DOTEST" || die "Could not create temporary $DOTEST"
647 : > "$DOTEST"/interactive || die "Could not mark as interactive"
648 git symbolic-ref HEAD > "$DOTEST"/head-name 2> /dev/null ||
649 echo "detached HEAD" > "$DOTEST"/head-name
651 echo $HEAD > "$DOTEST"/head
652 case "$REBASE_ROOT" in
654 rm -f "$DOTEST"/rebase-root ;;
656 : >"$DOTEST"/rebase-root ;;
658 echo $ONTO > "$DOTEST"/onto
659 test -z "$STRATEGY" || echo "$STRATEGY" > "$DOTEST"/strategy
660 test t = "$VERBOSE" && : > "$DOTEST"/verbose
661 if test t = "$PRESERVE_MERGES"
663 # $REWRITTEN contains files for each commit that is
664 # reachable by at least one merge base of $HEAD and
665 # $UPSTREAM. They are not necessarily rewritten, but
666 # their children might be.
667 # This ensures that commits on merged, but otherwise
668 # unrelated side branches are left alone. (Think "X"
669 # in the man page's example.)
670 if test -z "$REBASE_ROOT"
672 mkdir "$REWRITTEN" &&
673 for c in $(git merge-base --all $HEAD $UPSTREAM)
675 echo $ONTO > "$REWRITTEN"/$c ||
676 die "Could not init rewritten commits"
679 mkdir "$REWRITTEN" &&
680 echo $ONTO > "$REWRITTEN"/root ||
681 die "Could not init rewritten commits"
683 # No cherry-pick because our first pass is to determine
684 # parents to rewrite and skipping dropped commits would
685 # prematurely end our probe
687 first_after_upstream="$(git rev-list --reverse --first-parent $UPSTREAM..$HEAD | head -n 1)"
689 MERGES_OPTION="--no-merges --cherry-pick"
692 SHORTHEAD=$(git rev-parse --short $HEAD)
693 SHORTONTO=$(git rev-parse --short $ONTO)
694 if test -z "$REBASE_ROOT"
695 # this is now equivalent to ! -z "$UPSTREAM"
697 SHORTUPSTREAM=$(git rev-parse --short $UPSTREAM)
698 REVISIONS=$UPSTREAM...$HEAD
699 SHORTREVISIONS=$SHORTUPSTREAM..$SHORTHEAD
701 REVISIONS=$ONTO...$HEAD
702 SHORTREVISIONS=$SHORTHEAD
704 git rev-list $MERGES_OPTION --pretty=oneline --abbrev-commit \
705 --abbrev=7 --reverse --left-right --topo-order \
707 sed -n "s/^>//p" | while read shortsha1 rest
709 if test t != "$PRESERVE_MERGES"
711 echo "pick $shortsha1 $rest" >> "$TODO"
713 sha1=$(git rev-parse $shortsha1)
714 if test -z "$REBASE_ROOT"
717 for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
719 if test -f "$REWRITTEN"/$p -a \( $p != $ONTO -o $sha1 = $first_after_upstream \)
727 if test f = "$preserve"
729 touch "$REWRITTEN"/$sha1
730 echo "pick $shortsha1 $rest" >> "$TODO"
735 # Watch for commits that been dropped by --cherry-pick
736 if test t = "$PRESERVE_MERGES"
739 # Save all non-cherry-picked changes
740 git rev-list $REVISIONS --left-right --cherry-pick | \
741 sed -n "s/^>//p" > "$DOTEST"/not-cherry-picks
742 # Now all commits and note which ones are missing in
743 # not-cherry-picks and hence being dropped
744 git rev-list $REVISIONS |
747 if test -f "$REWRITTEN"/$rev -a "$(sane_grep "$rev" "$DOTEST"/not-cherry-picks)" = ""
749 # Use -f2 because if rev-list is telling us this commit is
750 # not worthwhile, we don't want to track its multiple heads,
751 # just the history of its first-parent for others that will
752 # be rebasing on top of it
753 git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$DROPPED"/$rev
754 short=$(git rev-list -1 --abbrev-commit --abbrev=7 $rev)
755 sane_grep -v "^[a-z][a-z]* $short" <"$TODO" > "${TODO}2" ; mv "${TODO}2" "$TODO"
761 test -s "$TODO" || echo noop >> "$TODO"
762 cat >> "$TODO" << EOF
764 # Rebase $SHORTREVISIONS onto $SHORTONTO
767 # p, pick = use commit
768 # r, reword = use commit, but edit the commit message
769 # e, edit = use commit, but stop for amending
770 # s, squash = use commit, but meld into previous commit
772 # If you remove a line here THAT COMMIT WILL BE LOST.
773 # However, if you remove everything, the rebase will be aborted.
777 has_action "$TODO" ||
778 die_abort "Nothing to do"
780 cp "$TODO" "$TODO".backup
781 git_editor "$TODO" ||
782 die_abort "Could not execute editor"
784 has_action "$TODO" ||
785 die_abort "Nothing to do"
787 test -d "$REWRITTEN" || skip_unnecessary_picks
789 git update-ref ORIG_HEAD $HEAD
790 output git checkout $ONTO && do_rest